﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AitoffProjection
{
    public partial class Form1 : Form
    {
        const int J = 4;

        const int WIDTH = 1024;
        const int HEIGHT = WIDTH/2;

        const double STEP = 0.25;

        const int COLPAR = 15;  // <=23

        const int NSIDE = 12;

        

        public Form1()
        {
            InitializeComponent();
            this.Height = HEIGHT + 70;
            this.Width = WIDTH + 50;

        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            Graphics g = e.Graphics;

            Sphere.SCALE = HEIGHT / 2;
            g.TranslateTransform(this.ClientSize.Width / 2, this.ClientSize.Height / 2);


            float x, y;
            for (double DA = -180; DA <= 180.0; DA += STEP)
            {
                double A = Sphere.rad(DA);
                for (double DD = -90; DD <= 90.0; DD += STEP)
                {
                    double D = Sphere.rad(DD);
                    double f = SphericalHarm.FVJ(J, DA, DD);
                    Sphere.Aitoff(DA, DD, out x, out y);
                    x *= -Sphere.SCALE;
                    y *= Sphere.SCALE;
                    Color color=Real2Color(f);
                    Brush b = new SolidBrush(color);
                    g.FillEllipse(b,x-1,y-1,3,3);
                }
            }

            Sphere.GridLines(g, 30.0);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        static Color Real2Color(double S)
        {

            int K = (int) Math.Abs(Math.Floor(S*255));
            if (K > 255) K = 255;
            if (S>0)
                return Color.FromArgb(255,255-K,255-K);
            else
                return Color.FromArgb(255-K, 255-K, 255);
        }


    }
}
