﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AitoffProjection
{
    class SphericalHarm
    {

        private static double A(int M, int N, int K) // Вспом фун для PL
        {
            double Up = 1.0, Dn = 1.0;

            for (int I = 0; I <= 2 * M - 1; I++)
                Up = Up * (N - K - I);

            for (int I = 1; I <= M; I++)
                Dn = Dn * 2 * I * (2 * (N - I) + 1);

            if (M % 2 == 0) return Up / Dn;
            else return -Up / Dn;
        }

        private static double NORM(int N, int K)
        {
            double Up = 1.0, Dn = 1.0;

            for (int I = N + 1; I <= 2 * N; I++)
                Up = Up * I;

            for (int I = 1; I <= N - K; I++)
                Dn = Dn * I;

            Up = Up / Dn;

            for (int I = 1; I <= N; I++)
                Up = Up * 0.5;

            return Up;
        }

        private static double Pow(double x, int n)
        {
            double z = 1.0;
            for (int i = 0; i < n; i++) z *= x;
            return z;
        }

        public static double PL(int N, int K, double D)
        {
            // N,K  ! Индексы полинома
            // Склонение или галактическая широта в градусах!
            double X, Z;
            int F;

            if (N < K) return 0.0;

            X = Math.Sin(Sphere.rad(D));

            F = (N - K) / 2;

            if (F == 0)
                Z = Pow(X, N - K) * Pow(Math.Sqrt(1 - X * X), K);
            else
            {
                Z = Pow(X, N - K);
                for (int M = 1; M <= F; M++)
                    Z += A(M, N, K) * Pow(X, N - K - 2 * M);
                Z *= Pow(Math.Sqrt(1 - X * X), K);
            }

            return NORM(N, K) * Z;
        }


        private static double FACT2(int N1, int N2)
        {
            // Произведение чисел от N1 до N2 
            double F = 1.0;
            for (int I = N1; I <= N2; I++)
                F *= I;
            return F;
        }



        private static double FR(int N, int K)
        {
            // Норма сферической функции
            double R = Math.Sqrt((2 * N + 1) / (4.0 * Math.PI));
            if (K > 0)
                R *= Math.Sqrt(2.0 / FACT2(N - K + 1, N + K));
            return R;
        }

        public static double FK(int N, int K, int L, double A, double D)
        {
            // Нормированная сферическая функция
            double F;
            if (K == 0) F = PL(N, 0, D);
            else
                if (L == 0)
                    F = PL(N, K, D) * Math.Sin(Sphere.rad(K * A));
                else
                    F = PL(N, K, D) * Math.Cos(Sphere.rad(K * A));
            return F * FR(N, K);
        }

        public static void INDEXES(int J, out int N, out int K, out int L)
        {
            // Вычисление индексов N,K,L по индексу J (J=N**2+2*K+L-1)
            N = (int) Math.Sqrt(J);
            K = J - N * N;
            if (K % 2 == 0) L = 1;
            else L = 0;
            K = (K - L + 1) / 2;
        }

        public static double FVJ(int J, double A, double D)
        // Нормированная сферическая функция от одного индекса
        // A,D  В градусах
        {
            int N, K, L;
            INDEXES(J, out N, out K, out L);
            return FK(N, K, L, A, D);
        }





    }
}
